#version 330

uniform bool backface;

in vec3 gs_normal[3];
out vec3 fs_normal;

layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;

void main()
{
    if(backface) {
        float xMin = 100, yMin = 100, xMax = -100, yMax = -100;
        for(int i = 0; i < gl_in.length(); i++) {
            if(gl_in[i].gl_Position.x < xMin) xMin = gl_in[i].gl_Position.x;
            if(gl_in[i].gl_Position.x > xMax) xMax = gl_in[i].gl_Position.x;
            if(gl_in[i].gl_Position.y < yMin) yMin = gl_in[i].gl_Position.y;
            if(gl_in[i].gl_Position.y > yMax) yMax = gl_in[i].gl_Position.y;
        }

        float xHalf = (xMax - xMin) / 2 + xMin;
        float yHalf = (yMax - yMin) / 2 + yMin;

        float offset = 0.07;

        //float scale = 3;
        //float xOffset = xHalf * (scale - 1);
        //float yOffset = yHalf * (scale - 1);

        for(int i = 0; i < gl_in.length(); i++) {
            gl_Position = gl_in[i].gl_Position;
            //gl_Position.x = gl_Position.x * scale - xOffset;
            //gl_Position.y = gl_Position.y * scale - yOffset;

            if(gl_Position.x > 0) {
                gl_Position.x += offset;
            } else if(gl_Position.x < 0) {
                gl_Position.x -= offset;
            }
            if(gl_Position.y > 0) {
                gl_Position.y += offset;
            } else if(gl_Position.y < 0) {
                gl_Position.y -= offset;
            }

            fs_normal = gs_normal[i];
            EmitVertex();
        }
        EndPrimitive();
    } else {
        for(int i = 0; i < gl_in.length(); i++) {
            gl_Position = gl_in[i].gl_Position;
            fs_normal = gs_normal[i];
            EmitVertex();
        }
        EndPrimitive();
    }
}
